/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *   qimsys                                                                  *
 *   Copyright (C) 2010 by Tasuku Suzuki <stasuku@gmail.com>                 *
 *                                                                           *
 *   This program is free software; you can redistribute it and/or modify    *
 *   it under the terms of the GNU General Lesser Public License as          *
 *   published by the Free Software Foundation; either version 2 of the      *
 *   License, or (at your option) any later version.                         *
 *                                                                           *
 *   This program is distributed in the hope that it will be useful,         *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           *
 *   GNU Lesser General Public License for more details.                     *
 *                                                                           *
 *   You should have received a copy of the GNU Lesser General Public        *
 *   License along with this program; if not, write to the                   *
 *   Free Software Foundation, Inc.,                                         *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.               *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#ifndef XIMCLIENT_H
#define XIMCLIENT_H

#include "qximinputmethod.h"

class XimClient : public QXimInputMethod
{
    Q_OBJECT
public:
    XimClient(QObject *parent = 0);
    ~XimClient();

    void updateHandler(UpdateType type);

protected:
    qulonglong winId();
    const char *name() const;
    const char *locale() const;
    bool filter(int unicode, int keycode, int modifiers, bool isPress, bool autoRepeat);

private:
    class Private;
    Private *d;
};

#include "qimsysabstractpluginobject.h"
class XimClientObject : public QimsysAbstractPluginObject
{
    Q_OBJECT
public:
    XimClientObject(QObject *parent = 0);
    ~XimClientObject();

private:
    class Private;
    Private *d;
};

#include "qimsysplugin.h"

class XimClientPlugin : public QimsysPlugin
{
    Q_OBJECT
    Q_INTERFACES(QimsysPlugin)
public:
    XimClientPlugin();

protected:
    QimsysAbstractPluginObject *createObject(QObject *parent);
};

#endif//XIMCLIENT_H
